package nc.pubimpl.so.m4331.pfxx;

import nc.bs.framework.common.NCLocator;
import nc.impl.pubapp.pattern.data.bill.BillQuery;
import nc.impl.pubapp.pattern.data.bill.tool.BillConcurrentTool;
import nc.impl.so.m4331.action.maintain.DeliveryInsertAction;
import nc.impl.so.m4331.action.maintain.DeliveryUpdateAction;
import nc.itf.uap.pf.IPFBusiAction;
import nc.pubitf.uapbd.CurrencyRateUtil;
import nc.vo.ecpubapp.pattern.exception.ExceptionUtils;
import nc.vo.pub.AggregatedValueObject;
import nc.vo.pub.BusinessException;
import nc.vo.pub.lang.UFDouble;
import nc.vo.so.m4331.entity.DeliveryBVO;
import nc.vo.so.m4331.entity.DeliveryHVO;
import nc.vo.so.m4331.entity.DeliveryVO;

/**
 * <b> ڴ˴ҪĹ </b>
 * 
 * <p>
 * ڴ˴ӴϢ
 * </p>
 * 
 * @author ufsoft
 * @version Your Project V60
 */
public class M4331PfxxPlugin extends nc.pubimpl.so.pfxx.AbstractSOPfxxPlugin {
  @Override
  protected AggregatedValueObject insert(AggregatedValueObject vo) {
    DeliveryVO[] insertvo = new DeliveryVO[] {
      (DeliveryVO) vo
    };
    /**
     * ԴĿıѯָڵĻ
     * 
     * @param src_currency_pk
     *            Դ
     * @param dest_currency_pk
     *            ĿıֵΪnullʱΪĬĿı
     * @param date
     * @return
     * @throws BusinessException
     */
    DeliveryVO newvo = insertvo[0];
    DeliveryHVO headvo = newvo.getParentVO();
    CurrencyRateUtil currRateUtil = CurrencyRateUtil
				.getInstanceByOrg(headvo.getPk_org());
    DeliveryBVO[] bodyvos = newvo.getChildrenVO();
    for(DeliveryBVO bodyvo:bodyvos){
    	String corigcurrencyid = bodyvo.getCorigcurrencyid();//ԭ
    	String ccurrencyid= bodyvo.getCcurrencyid();//λ
    	try {
			if(corigcurrencyid.equals(ccurrencyid)){
					UFDouble nqtorigtaxprice = bodyvo.getNqtorigtaxprice();//˰
					UFDouble nqtorigprice = bodyvo.getNqtorigprice();//˰
					UFDouble norigmny = bodyvo.getNorigmny();//˰
					UFDouble norigtaxmny = bodyvo.getNorigtaxmny();//˰ϼ
					bodyvo.setNcaltaxmny(norigtaxmny);//˰
					bodyvo.setNqttaxprice(nqtorigtaxprice);//Һ˰
					bodyvo.setNqtprice(nqtorigprice);//˰
					bodyvo.setNqttaxnetprice(nqtorigtaxprice);//Һ˰
//					bodyvo.setNorigtaxnetprice(nqtorigtaxprice);//˰
//					bodyvo.setNorignetprice(nqtorigprice);//˰
					bodyvo.setNqtnetprice(nqtorigprice);//˰
//					bodyvo.setNtaxprice(nqtorigtaxprice);//Һ˰
					bodyvo.setNpiece(nqtorigprice);//˰
//					bodyvo.setNtaxnetprice(nqtorigtaxprice);//Һ˰
					bodyvo.setNnetprice(nqtorigprice);//˰
					bodyvo.setNmny(norigmny);//˰
					bodyvo.setNtaxmny(norigtaxmny);//Ҽ˰ϼ
					bodyvo.setNqtorigtaxnetprc(nqtorigtaxprice);//˰
					bodyvo.setNqtorignetprice(nqtorigprice);//˰
					continue;
				}
				UFDouble foreignrate = currRateUtil.getRate(corigcurrencyid,/*ԭ*/
						ccurrencyid/**/, headvo.getDbilldate());//
				bodyvo.setNexchangerate(foreignrate);
				//norigprice ԭ˰
				UFDouble norigprice=bodyvo.getNorigtaxprice();//ԭҺ˰
				UFDouble foreignAmount=	currRateUtil.getAmountByOpp(corigcurrencyid,
						ccurrencyid, norigprice, foreignrate, headvo.getDbilldate());
//				bodyvo.setNtaxprice(foreignAmount);//Һ˰
				UFDouble ngprice=currRateUtil.getAmountByOpp(corigcurrencyid,
						ccurrencyid, bodyvo.getNorigprice()/*ԭ˰*/, foreignrate, headvo.getDbilldate());
				bodyvo.setNprice(ngprice); // ˰
				bodyvo.setNqtprice(ngprice); //۱˰
				bodyvo.setNqttaxprice(foreignAmount);//۱Һ˰
				UFDouble nmny=currRateUtil.getAmountByOpp(corigcurrencyid,
						ccurrencyid, bodyvo.getNorigmny()/*ԭ˰*/, foreignrate, headvo.getDbilldate());
				bodyvo.setNmny(nmny);//˰  
				UFDouble ntaxmny=currRateUtil.getAmountByOpp(corigcurrencyid,
						ccurrencyid, bodyvo.getNorigtaxmny()/*ԭҼ˰ϼ*/, foreignrate, headvo.getDbilldate());
				bodyvo.setNtaxmny(ntaxmny);//ntaxmny Ҽ˰ϼ
				bodyvo.setNcaltaxmny(ntaxmny);//˰
				bodyvo.setNqtnetprice(ngprice);//˰
				bodyvo.setNnetprice(ngprice);//˰
//				bodyvo.setNorigtaxnetprice(foreignAmount);//˰
//				bodyvo.setNorignetprice(ngprice);//˰
//				bodyvo.setNqttaxnetprice(foreignAmount);//Һ˰
				bodyvo.setNtaxnetprice(foreignAmount);//Һ˰
				bodyvo.setNtax(ntaxmny.sub(nmny));//˰=˰ϼ-˰
				bodyvo.setNqtorigtaxnetprc(foreignAmount);//˰
				bodyvo.setNqtorignetprice(ngprice);//˰
				
				
				bodyvo.setNorignetprice(bodyvo.getNorigprice());//˰
				bodyvo.setNorigtaxnetprice(bodyvo.getNorigtaxprice());//˰
				bodyvo.setNtaxnetprice(bodyvo.getNorigtaxprice());//Һ˰
				bodyvo.setNtaxprice(bodyvo.getNorigtaxprice());//Һ˰
		} catch (BusinessException e) {
			// TODO Զɵ catch 
			ExceptionUtils.wrappBusinessException(e.getMessage());
		}
	}
    
    
   /* DeliveryInsertAction insert = new DeliveryInsertAction();
    try {
		DeliveryVO[] ret = insert.insert(insertvo);
		if (null == ret || ret.length == 0) {
		  return null;
		}
		IPFBusiAction service = NCLocator.getInstance().lookup(IPFBusiAction.class);
		DeliveryVO[] approvevos = (DeliveryVO[]) service.processAction("APPROVE", "4331", null, ret[0], null, null);
		return approvevos[0];
	} catch (Exception e) {
		// TODO Զɵ catch 
		e.printStackTrace();
		ExceptionUtils.wrappBusinessException(e.getMessage());
		
	}
	return insertvo[0];*/
    
    DeliveryInsertAction insert = new DeliveryInsertAction();
    DeliveryVO[] ret = insert.insert(insertvo);
    if (null == ret || ret.length == 0) {
      return null;
    }
    return ret[0];
    
    
  }

  @Override
  protected AggregatedValueObject update(AggregatedValueObject vo, String vopk) {
    DeliveryVO[] updatevo = new DeliveryVO[] {
      (DeliveryVO) vo
    };
    BillQuery<DeliveryVO> billquery =
        new BillQuery<DeliveryVO>(DeliveryVO.class);
    DeliveryVO[] origvos = billquery.query(new String[] {
      vopk
    });
    BillConcurrentTool tool = new BillConcurrentTool();
    tool.lockBill(origvos);
    DeliveryUpdateAction update = new DeliveryUpdateAction();
    DeliveryVO[] retvos = update.update(updatevo, origvos);
    if (null == retvos || retvos.length == 0) {
      return null;
    }
    return retvos[0];
  }
}
